| Fast DDS Version 3.3.0 Fast DDS

Loading...
Searching...
No Matches
TypeDescriptor Class Referenceabstract

TypeDescriptor definition according to [standard] section 7.5.2.4. More...

`#include <TypeDescriptor.hpp>`

## Public Types

using | _ref_type = typename traits<TypeDescriptor>::ref_type

## Public Member Functions

virtual TypeKind | kind () const =0
| Returns the TypeKind associated.
virtual TypeKind & | kind ()=0
| Returns the TypeKind associated.
virtual void | kind (TypeKind kind)=0
| Modifies the underlying TypeKind.
virtual ObjectName & | name ()=0
| Returns the fully qualified name of this type.
virtual const ObjectName & | name () const =0
| Returns the fully qualified name of this type.
virtual void | name (const ObjectName &name)=0
| Modifies the underlying type name by copy.
virtual void | name (ObjectName &&name)=0
| Modifies the underlying type name by move.
virtual traits< DynamicType >::ref_type | base_type () const =0
| Returns a reference to the base type.
virtual traits< DynamicType >::ref_type & | base_type ()=0
| Returns a reference to the base type.
virtual void | base_type (traits< DynamicType >::ref_type type)=0
| Modifies the underlying base type reference.
virtual traits< DynamicType >::ref_type | discriminator_type () const =0
| Returns a reference discriminator type.
virtual traits< DynamicType >::ref_type & | discriminator_type ()=0
| Returns a reference discriminator type.
virtual void | discriminator_type (traits< DynamicType >::ref_type type)=0
| Modifies the underlying discriminator type reference.
virtual const BoundSeq & | bound () const =0
| Returns the bound.
virtual BoundSeq & | bound ()=0
| Returns the bound.
virtual void | bound (const BoundSeq &bound)=0
| Modifies the underlying bound by copy.
virtual void | bound (BoundSeq &&bound)=0
| Modifies the underlying bound by move.
virtual traits< DynamicType >::ref_type | element_type () const =0
| Returns a reference element type.
virtual traits< DynamicType >::ref_type & | element_type ()=0
| Returns a reference element type.
virtual void | element_type (traits< DynamicType >::ref_type type)=0
| Modifies the underlying element type reference.
virtual traits< DynamicType >::ref_type | key_element_type () const =0
| Returns a reference key element type.
virtual traits< DynamicType >::ref_type & | key_element_type ()=0
| Returns a reference key element type.
virtual void | key_element_type (traits< DynamicType >::ref_type type)=0
| Modifies the underlying key element type reference.
virtual ExtensibilityKind | extensibility_kind () const =0
| Returns the extensibility kind.
virtual ExtensibilityKind & | extensibility_kind ()=0
| Returns the extensibility kind.
virtual void | extensibility_kind (ExtensibilityKind extensibility_kind)=0
| Modifies the extensibility kind.
virtual bool | is_nested () const =0
| Returns the is_nested property.
virtual bool & | is_nested ()=0
| Returns the is_nested property.
virtual void | is_nested (bool is_nested)=0
| Modifies the is_nested property.
virtual ReturnCode_t | copy_from (traits< TypeDescriptor >::ref_type descriptor)=0
| Overwrites the contents of this descriptor with those of another descriptor (see [standard] 7.5.2.4.3).
virtual bool | equals (traits< TypeDescriptor >::ref_type descriptor)=0
| Compares according with the [standard] section 7.5.2.4.6.
virtual bool | is_consistent ()=0
| Indicates whether the states of all of this descriptor's properties are consistent according with the [standard] section 7.5.2.4.7.

## Protected Member Functions

| TypeDescriptor ()=default
| TypeDescriptor (const TypeDescriptor &type)=default
| TypeDescriptor (TypeDescriptor &&type)=default
virtual | ~TypeDescriptor ()=default

## Detailed Description

TypeDescriptor definition according to [standard] section 7.5.2.4.

## Member Typedef Documentation

## ◆ _ref_type

using _ref_type = typename traits<TypeDescriptor>::ref_type

## Constructor & Destructor Documentation

## ◆ TypeDescriptor() [1/3]

TypeDescriptor | ( |  | ) |

protected default

## ◆ TypeDescriptor() [2/3]

TypeDescriptor | ( | const TypeDescriptor & | type | ) |

protected default

## ◆ TypeDescriptor() [3/3]

TypeDescriptor | ( | TypeDescriptor && | type | ) |

protected default

## ◆ ~TypeDescriptor()

virtual ~TypeDescriptor | ( |  | ) |

protected virtual default

## Member Function Documentation

## ◆ base_type() [1/3]

virtual traits< DynamicType >::ref_type base_type | ( |  | ) | const

pure virtual

Returns a reference to the base type.

The reference can be nil.

Returns
  DynamicType reference.

## ◆ base_type() [2/3]

virtual traits< DynamicType >::ref_type & base_type | ( |  | ) |

pure virtual

Returns a reference to the base type.

The reference can be nil.

Returns
  DynamicType reference.

## ◆ base_type() [3/3]

virtual void base_type | ( | traits< DynamicType >::ref_type | type | ) |

pure virtual

Modifies the underlying base type reference.

Parameters

  [in] | type | DynamicType reference.

## ◆ bound() [1/4]

virtual const BoundSeq & bound | ( |  | ) | const

pure virtual

Returns the bound.

Returns
  BoundSeq.

## ◆ bound() [2/4]

virtual BoundSeq & bound | ( |  | ) |

pure virtual

Returns the bound.

Returns
  BoundSeq.

## ◆ bound() [3/4]

virtual void bound | ( | BoundSeq && | bound | ) |

pure virtual

Modifies the underlying bound by move.

Parameters

  [in] | bound | BoundSeq

## ◆ bound() [4/4]

virtual void bound | ( | const BoundSeq & | bound | ) |

pure virtual

Modifies the underlying bound by copy.

Parameters

  [in] | bound | BoundSeq

## ◆ copy_from()

virtual ReturnCode_t copy_from | ( | traits< TypeDescriptor >::ref_type | descriptor | ) |

pure virtual

Overwrites the contents of this descriptor with those of another descriptor (see [standard] 7.5.2.4.3).

Parameters

  [in] | descriptor | reference.

Returns
  ReturnCode_t

Return values

  RETCODE_OK | when the copy was successful.
  RETCODE_BAD_PARAMETER | when descriptor reference is nil.

## ◆ discriminator_type() [1/3]

virtual traits< DynamicType >::ref_type discriminator_type | ( |  | ) | const

pure virtual

Returns a reference discriminator type.

The reference can be nil.

Returns
  DynamicType reference.

## ◆ discriminator_type() [2/3]

virtual traits< DynamicType >::ref_type & discriminator_type | ( |  | ) |

pure virtual

Returns a reference discriminator type.

The reference can be nil.

Returns
  DynamicType reference.

## ◆ discriminator_type() [3/3]

virtual void discriminator_type | ( | traits< DynamicType >::ref_type | type | ) |

pure virtual

Modifies the underlying discriminator type reference.

Parameters

  [in] | type | DynamicType reference.

## ◆ element_type() [1/3]

virtual traits< DynamicType >::ref_type element_type | ( |  | ) | const

pure virtual

Returns a reference element type.

The reference can be nil.

Returns
  DynamicType reference.

## ◆ element_type() [2/3]

virtual traits< DynamicType >::ref_type & element_type | ( |  | ) |

pure virtual

Returns a reference element type.

The reference can be nil.

Returns
  DynamicType reference.

## ◆ element_type() [3/3]

virtual void element_type | ( | traits< DynamicType >::ref_type | type | ) |

pure virtual

Modifies the underlying element type reference.

Parameters

  [in] | type | DynamicType reference.

## ◆ equals()

virtual bool equals | ( | traits< TypeDescriptor >::ref_type | descriptor | ) |

pure virtual

Compares according with the [standard] section 7.5.2.4.6.

Parameters

  [in] | descriptor | reference to compare to.

Returns
  bool true on equality

## ◆ extensibility_kind() [1/3]

virtual ExtensibilityKind extensibility_kind | ( |  | ) | const

pure virtual

Returns the extensibility kind.

return ExtensibilityKind

## ◆ extensibility_kind() [2/3]

virtual ExtensibilityKind & extensibility_kind | ( |  | ) |

pure virtual

Returns the extensibility kind.

return ExtensibilityKind

## ◆ extensibility_kind() [3/3]

virtual void extensibility_kind | ( | ExtensibilityKind | extensibility_kind | ) |

pure virtual

Modifies the extensibility kind.

Parameters

  [in] | extensibility_kind | ExtensibilityKind

## ◆ is_consistent()

virtual bool is_consistent | ( |  | ) |

pure virtual

Indicates whether the states of all of this descriptor's properties are consistent according with the [standard] section 7.5.2.4.7.

Returns
  bool true if consistent.

## ◆ is_nested() [1/3]

virtual bool is_nested | ( |  | ) | const

pure virtual

Returns the is_nested property.

return Boolean

## ◆ is_nested() [2/3]

virtual bool & is_nested | ( |  | ) |

pure virtual

Returns the is_nested property.

return Boolean

## ◆ is_nested() [3/3]

virtual void is_nested | ( | bool | is_nested | ) |

pure virtual

Modifies the is_nested property.

Parameters

  [in] | is_nested | Boolean value to be set.

## ◆ key_element_type() [1/3]

virtual traits< DynamicType >::ref_type key_element_type | ( |  | ) | const

pure virtual

Returns a reference key element type.

The reference can be nil.

Returns
  DynamicType reference.

## ◆ key_element_type() [2/3]

virtual traits< DynamicType >::ref_type & key_element_type | ( |  | ) |

pure virtual

Returns a reference key element type.

The reference can be nil.

Returns
  DynamicType reference.

## ◆ key_element_type() [3/3]

virtual void key_element_type | ( | traits< DynamicType >::ref_type | type | ) |

pure virtual

Modifies the underlying key element type reference.

Parameters

  [in] | type | DynamicType reference.

## ◆ kind() [1/3]

virtual TypeKind kind | ( |  | ) | const

pure virtual

Returns the TypeKind associated.

Returns
  standard TypeKind.

## ◆ kind() [2/3]

virtual TypeKind & kind | ( |  | ) |

pure virtual

Returns the TypeKind associated.

Returns
  standard TypeKind.

## ◆ kind() [3/3]

virtual void kind | ( | TypeKind | kind | ) |

pure virtual

Modifies the underlying TypeKind.

Parameters

  [in] | kind | TypeKind to be set.

## ◆ name() [1/4]

virtual const ObjectName & name | ( |  | ) | const

pure virtual

Returns the fully qualified name of this type.

Returns
  Fully qualified name.

## ◆ name() [2/4]

virtual ObjectName & name | ( |  | ) |

pure virtual

Returns the fully qualified name of this type.

Returns
  Fully qualified name.

## ◆ name() [3/4]

virtual void name | ( | const ObjectName & | name | ) |

pure virtual

Modifies the underlying type name by copy.

Parameters

  [in] | name | Fully qualified name.

## ◆ name() [4/4]

virtual void name | ( | ObjectName && | name | ) |

pure virtual

Modifies the underlying type name by move.

Parameters

  [in] | name | Fully qualified name.

The documentation for this class was generated from the following file:

- include/fastdds/dds/xtypes/dynamic_types/TypeDescriptor.hpp